#include "bot_admin_function.h"

int readStruct(BOT *cb, FILE *file, int posStruct){

	int i, nbRead;
	char title[] = "Lecture de structure";
	
	if(file == NULL){ 
		Menu(1, title, "Fichier de données introuvable", "Menu principal");
		return 0;
	}

	fseek(file, posStruct, SEEK_SET);
	nbRead = MyRead(cb, file, 1);

	if(nbRead > 0){

		TurnOnBold();
		printf("Structure n°%d \n\n", (int)(posStruct/sizeof(BOT)) );
		TurnOffBold();

		printf("Nombre de mot-clés : %d \n", cb->nbKeyWord);
		printf("Thème :              %d \n", cb->theme);
		printf("Action :             %d \n\n", cb->action);

		for(i=0; i < cb->nbKeyWord; i++){ printf("Mot-clé n°%d : %s \n", i, cb->keyWord[i]); }

		TurnOnBold();
		printf("\nConversation type : \n");
		TurnOffBold();
		printf("\nUtilisateur : ");
		for(i=0; i < cb->nbKeyWord; i++){ printf("%s ", cb->keyWord[i]); }
		printf("\nRéponse : %s \n", cb->answer);
		TurnOffBold();

		TurnOnBold();
		Couleur("34");
	}
	else{ 
		return Menu(1, title,"Il n'y a pas d'autres structure dans ce theme","Menu principal"); 
	}
		
	TurnOffBold();
	Couleur("0");
	
	return nbRead;
}

void writeStruct(BOT *cb, FILE *file, int posStruct){

	int i, continuer;
	char title[] = "Ecriture de structure";

	if(file == NULL){ 
		Menu(1, title, "Fichier de données introuvabe", "Menu principal");
		return;
	}

	do{
		continuer=Menu(4, title, "Modification","Mot-clé", "Réponse", "Action", "Enregister");

		switch(continuer){
			case 3:
				i = Menu( (cb->nbKeyWord+1) , \
				title, 			\
				"Mot-clé de la structure", \
				"[Nouveau mot-clé]", \
				cb->keyWord[0], \
				cb->keyWord[1], \
				cb->keyWord[2], \
				cb->keyWord[3], \
				cb->keyWord[4], \
				cb->keyWord[5], \
				cb->keyWord[6], \
				cb->keyWord[7], \
				cb->keyWord[8], \
				cb->keyWord[9], \
				cb->keyWord[10], \
				cb->keyWord[11], \
				cb->keyWord[12], \
				cb->keyWord[13], \
				cb->keyWord[14], \
				cb->keyWord[15], \
				cb->keyWord[16], \
				cb->keyWord[17], \
				cb->keyWord[18], \
				cb->keyWord[19], \
				cb->keyWord[20], \
				cb->keyWord[21], \
				cb->keyWord[22], \
				cb->keyWord[23], \
				cb->keyWord[24], \
				cb->keyWord[25], \
				cb->keyWord[26], \
				cb->keyWord[27], \
				cb->keyWord[28], \
				cb->keyWord[29], \
				cb->keyWord[30], \
				cb->keyWord[31], \
				cb->keyWord[32], \
				cb->keyWord[33], \
				cb->keyWord[34], \
				cb->keyWord[35], \
				cb->keyWord[36], \
				cb->keyWord[37], \
				cb->keyWord[38], \
				cb->keyWord[39], \
				cb->keyWord[40], \
				cb->keyWord[41], \
				cb->keyWord[42], \
				cb->keyWord[43], \
				cb->keyWord[44], \
				cb->keyWord[45], \
				cb->keyWord[46], \
				cb->keyWord[47], \
				cb->keyWord[48], \
				cb->keyWord[49]);
				
				printf("Nombre de mot-clés : %d \n\n", cb->nbKeyWord);
				if(i >= cb->nbKeyWord){
					printf("Mot-clé n°%d <undefined> \n", (cb->nbKeyWord+1) );
					printf("> Nouveau : \n\t> ");
					scanf("%s", cb->keyWord[(cb->nbKeyWord)] );
					ClearBuff();
					cb->nbKeyWord++;
				}
				else{
					printf("Mot-clé n°%d : %s \n", (cb->nbKeyWord-i-1), cb->keyWord[(cb->nbKeyWord-i-1)]);
					printf("> Nouveau : \n\t> ");
					scanf("%s", cb->keyWord[(cb->nbKeyWord-i-1)]);
					ClearBuff();
				}
				break;
			case 2:
				printf("Réponse : %s \n", cb->answer);
				printf("> Nouveau : \n\t> ");
				strcpy(cb->answer, UnlimitedScanKey());
				break;
			case 1:
				cb->action= (Menu(5,\
				title,
				"Action à effectuer en cas d'utilisation de la structure", \
				"Recherche GOOGLE", \
				"Calculatrice", \
				"Ouvrir une page web", \
				"Continuer", \
				"Quitter") - 1);
	
				printf("Action : %d \n\n", cb->action);
				break;
			case 0:
				continuer = 0;
				break;
			default :
				continuer = 0;
		}

	}while(continuer > 0);
	
	fseek(file, posStruct, SEEK_SET);
	fwrite(cb, sizeof(BOT), 1, file);
}

int searchStruct(BOT *cb, FILE *file, int *posStruct){

	int i, j, continuer;
	int nbFilter, nbValidStruct=0, nbValidFilter, nbStruct;
	char title[]="Modification de structure", filter[10][30];

			/* choix du filtre sur Mot-clé */
	nbFilter=0;
	
	do{
		do{
				/* On se place au début du fichier */
			rewind(file);
			nbStruct = 0;

			printf("Filtre : \n\t> ");
				/* On ajoute le mot clé au tableau des filtres*/
			scanf("%s", filter[nbFilter]);
			ClearBuff();

				/* On incrémente le nombre de mots clés */
			nbFilter++;
	
			ClearWithHeader(title);
	
			for(j=0; j<nbFilter; j++){ printf("> Filtre n°%d : %s \n", (j+1), filter[j]); }

		}while( yesNoQuestion("Ajouter un filtre ?", 1) );

			/* Initialisation du nombre de structures valides */
		nbValidStruct = 0;

		while(MyRead(cb, file, 1) > 0){

			nbValidFilter = 0;
				/* On teste tous les mot-clés */
			for(j=0; j < nbFilter; j++){		

					/* On compare le filtre aux mot-clés de la structure */
				for(i=0; i < cb->nbKeyWord; i++){
						/* Si un mot-clé correspond, on le comptabilise et on change de filtre */
					if( (strcmp(cb->keyWord[i], filter[j]) == 0) ){
						nbValidFilter++;
						break;
					}
				}
				if(nbValidFilter == nbFilter){ 
					posStruct[nbValidStruct] = sizeof(BOT)*nbStruct;
					nbValidStruct++; 
					break; 
				}
			}
			nbStruct++;
		}

		if(nbValidStruct > 5){ 
			continuer = 1; 
			ClearWithHeader(title);
			TurnOnBold();
			printf("Nombre de filtres insuffisants pour déterminer la structure recherchée\n\n");

			for(i=0; i < nbFilter; i++){ printf("Filtre n°%d : %s \n", i, filter[i]); }
			TurnOffBold();
		}
		else if(nbValidStruct > 0 && nbValidStruct < 6){ continuer = 0; }
		else{ return 0;	}

	}while(continuer);

	fseek(file, posStruct[0], SEEK_SET);

	return nbValidStruct;
}
