#include "../inc/bot_analyze.h"
#include "../inc/bot_file.h"

char Reply(char *UserString, BOT *AnswerStruct,BOT *OldStruct,int Theme,char *Login,FILE *LogFile){
	
	BOT UserStruct, ReadStruct;
	
	FILE *ThemeFile=NULL;
	char NameFile[50];
	
	float ErrorRate=0;
	int OldNbSameWord=0;
	
	char ReturnValue;
	
	int OldTheme=Theme;
	int Repeat=0;

	char *UserStr;
	
	UserStr = strdup(UserString);

	ScanKeyWord(&UserStruct,UserStr,DEL_DOUBLE);	

	do{			
		ThemeFile = NULL;
		ConvertTheme(Theme,NameFile);
		strcat(NameFile,".dat");

		ThemeFile = fopen(NameFile,"rb");
		
		if(ThemeFile == NULL){
			ReturnValue = 1;
			Theme++;
			if(Theme == MAX_THEME)	Theme = 0;
		}
		
		else{
			while(MyRead(&ReadStruct,ThemeFile,1)>0){
				if(!CompareStruct(ReadStruct,UserStruct, &ErrorRate, &OldNbSameWord)){
					structCopy(AnswerStruct,&ReadStruct);
				}
			}
			
						
						
			if(ErrorRate != 0){	
				
				
				/* On teste si la structure est identique a précédemment */
				if(AnswerStruct->action == 0){
					if(!structKeyWordCmp(&OldStruct[4], AnswerStruct)){
						AnswerStruct->action = 0;
						ReturnValue = -2;
					}
					else if(!structKeyWordCmp(&OldStruct[3], AnswerStruct)){
						AnswerStruct->action = 0;
						ReturnValue = -3;
					}
					else if(!structKeyWordCmp(&OldStruct[2], AnswerStruct)){
						AnswerStruct->action = 0;
						ReturnValue = -4;
					}
					else if(!structKeyWordCmp(&OldStruct[1], AnswerStruct)){
						AnswerStruct->action = 0;
						ReturnValue = -5;
					}
					else if(!structKeyWordCmp(&OldStruct[0], AnswerStruct)){
						AnswerStruct->action = 0;
						ReturnValue = -6;
					}
					else{
						ReturnValue = 0;
					
						/* Enregistrement et décalage des ancienne structure */
						structCopy(&OldStruct[0],&OldStruct[1]);
						structCopy(&OldStruct[1],&OldStruct[2]);
						structCopy(&OldStruct[2],&OldStruct[3]);
						structCopy(&OldStruct[3],&OldStruct[4]);
						structCopy(&OldStruct[4],AnswerStruct);	
						/* FIN */
					}
				}
				else{
					ReturnValue = 0;
				}
				/* FIN */
	
				
				
				fclose(ThemeFile);
							
			}
			else{
				fclose(ThemeFile);
				ReturnValue = 1;
				Theme++;
				if(Theme == MAX_THEME)	Theme = 0;
			}
		}
		
		if(ReturnValue == 1 && Theme == OldTheme && Repeat==0){

			if(!strcmp(UserStruct.keyWord[UserStruct.nbKeyWord-1],"!")){
				ReturnValue = ReponseInterrogative(UserStr,Login);
				AnswerStruct->action=0;				
			}
			else{
				Couleur("32");
				TurnOnBold();
				printf("> Desole, j'ecoutais pas, tu disais ? \n");
				WriteLog(LogFile,"> Desole, j'ecoutais pas, tu disais ? \n");
				Couleur("0");
				TurnOnBold();
				printf("%s : ",Login);
				UserStr = UnlimitedScanKey();
				WriteLog(LogFile,"%s : %s \n",Login,UserStr);

				ScanKeyWord(&UserStruct,UserStr,DEL_DOUBLE);
			
				Repeat++;
			}
		}
		
		else if(ReturnValue == 1 && Theme == OldTheme && Repeat==1){
			Couleur("32");
			TurnOnBold();
			printf("> Quoi ? Tu veux que je te dises quoi a ça ? \n");
			WriteLog(LogFile,"> Quoi ? Tu veux que je te dises quoi a ça ? \n");
			Couleur("0");
			TurnOnBold();
			printf("Réponse : ");
			UserStr = UnlimitedScanKey();
			WriteLog(LogFile,"Réponse : %s \n",UserStr);
			strncpy(UserStruct.answer,UserStr,499);
			strncpy(AnswerStruct->answer,UserStr,499);			
			
			ThemeFile = fopen("moderate.dat","ab");
			

			if(ThemeFile != NULL){
				fwrite(&UserStruct,sizeof(BOT),1,ThemeFile);
				fclose(ThemeFile);
			}			
			AnswerStruct->action = 0;
			ReturnValue = -1;

			
		}
	}while(ReturnValue == 1);

	/*free(UserStr);*/
	return ReturnValue;
}

/************************************************************************
Nom 		: WriteLog

Paramètres	: LogFile - Pointeur de type FILE vers le fichier ou on 
			  souhaite écrire.
			  format - Chaine de caractère a écrire
			  
Description	: Cette fonction écrit dans le fichier pointé par LogFile
			  la chaine de caractère passé en argument, si celui-ci
			  existe. 
			  Cette fonction est un équivalent de fprintf() avec une
			  sécurité pour empecher la tentative d'écriture dans un
			  fichier inexistant.
			  
Retourne 	: Cette fonction renvoie le nombre d'octets écrit ou -1
			  si le fichier n'a pu être ouvert.
*************************************************************************/
int CompareStruct(BOT ReadStruct, BOT UserStruct, float *ErrorRate, int *OldNbSameWord){

	int nbSameWord = 0;
	int cpt[2];
	int ReturnValue=1;
	
	for(cpt[0]=0;cpt[0]<ReadStruct.nbKeyWord;cpt[0]++){				
			for(cpt[1]=0;cpt[1]<UserStruct.nbKeyWord;cpt[1]++){
				if(!strcmp(ReadStruct.keyWord[cpt[0]],UserStruct.keyWord[cpt[1]])){
					nbSameWord++;
				}
			}
	}
	
	if((nbSameWord/(ReadStruct.nbKeyWord)) >= ERROR_RATE && (nbSameWord/(ReadStruct.nbKeyWord)) >= *ErrorRate){
		if(nbSameWord >= *OldNbSameWord){
			*ErrorRate = nbSameWord/(ReadStruct.nbKeyWord);
			*OldNbSameWord = nbSameWord;
			ReturnValue=0;
		}
	}
	
	return ReturnValue;
}	

char ReponseInterrogative(char *Str, char *Login){

	BOT UserStruct;
	int cpt;

	Couleur("32");
	TurnOnBold();

	while(str_replace(&Str,"!","?"));

	if(WordReplace(&Str,"tu","je") || WordReplace(&Str,"Tu","je")){
		Str = ConjugVerbe(Str,0);
		printf("Réellement, %s \n",Str);

		Couleur("0");
		TurnOnBold();
		printf("%s : ",Login);
		Str = UnlimitedScanKey();
		ScanKeyWord(&UserStruct,Str,DEL_DOUBLE);
		Couleur("32");
		TurnOnBold();
		for(cpt=0;cpt<UserStruct.nbKeyWord;cpt++){
			if(!strcmp(UserStruct.keyWord[cpt],"oui")){
				printf("> Rien à foutre !\n");
				break;
			}
			else if(!strcmp(UserStruct.keyWord[cpt],"non")){
				printf("> C'est pas bien de mentir ! \n");
				break;
			}
		}
		if(cpt == UserStruct.nbKeyWord)
			printf("> Ok :) \n");


	}	
	else if(WordReplace(&Str,"je","tu") || WordReplace(&Str,"Je","tu")){
		Str = ConjugVerbe(Str,1);
		printf("Réellement, %s \n",Str);

		Couleur("0");
		TurnOnBold();
		printf("%s : ",Login);
		Str = UnlimitedScanKey();
		ScanKeyWord(&UserStruct,Str,DEL_DOUBLE);
		Couleur("32");
		TurnOnBold();
		for(cpt=0;cpt<UserStruct.nbKeyWord;cpt++){
			if(!strcmp(UserStruct.keyWord[cpt],"oui")){
				printf("> Rien à foutre !\n");
				break;
			}
			else if(!strcmp(UserStruct.keyWord[cpt],"non")){
				printf("> C'est pas bien de mentir ! \n");
				break;
			}
		}
		if(cpt == UserStruct.nbKeyWord)
			printf("> Ok :) \n");
	}
	else if(WordReplace(&Str,"vous","je") || WordReplace(&Str,"Vous","je")){
		Str = ConjugVerbe(Str,2);
		printf("Réellement, %s \n",Str);

		Couleur("0");
		TurnOnBold();
		printf("%s : ",Login);
		Str = UnlimitedScanKey();
		ScanKeyWord(&UserStruct,Str,DEL_DOUBLE);
		Couleur("32");
		TurnOnBold();
		for(cpt=0;cpt<UserStruct.nbKeyWord;cpt++){
			if(!strcmp(UserStruct.keyWord[cpt],"oui")){
				printf("> Rien à foutre !\n");
				break;
			}
			else if(!strcmp(UserStruct.keyWord[cpt],"non")){
				printf("> C'est pas bien de mentir ! \n");
				break;
			}
		}
		if(cpt == UserStruct.nbKeyWord)
			printf("> Ok :) \n");
	}
	else{
		printf("> Ok :) \n");
	}
	
	Couleur("0");
	TurnOffBold();

	return -7;

}
/*	int cpt;
	char Rep=0;
	BOT Tmp;
	
	
	while(str_replace(&Str,"!","?"));
	if(WordReplace(&Str,"je","vous") || WordReplace(&Str,"j'ai","vous avez") || str_replace(&Str,"j'","vous")){
		while(WordReplace(&Str,"je","vous"));	
		while(WordReplace(&Str,"j'ai","vous avez"));
		while(WordReplace(&Str,"me","vous"));
		while(str_replace(&Str,"j'","vous"));
		Str = ConjugVerbe(Str,1);		
	}
	else if(WordReplace(&Str,"vous","je")){
		while(WordReplace(&Str,"vous","je"));
		while(WordReplace(&Str,"etes","suis"));
		Str = ConjugVerbe(Str,5);	
	}
	else{
		while(WordReplace(&Str,"t'es"," je suis "));	
		while(str_replace(&Str,"t'","m'"));
		while(WordReplace(&Str,"te","me"));
		while(WordReplace(&Str,"tu","je"));
		Str = ConjugVerbe(Str,2);	
	}

	for(cpt=0;Str[cpt] != '?';cpt++);
	Str[cpt+1]='\0';



	Couleur("32");
	TurnOnBold();
	printfDelay("> Reellement ? ",1,1);	
	printfDelay(Str,15,1);
	Couleur("0");
	TurnOnBold();
	printf("\n%s : ",Login);

	Str = UnlimitedScanKey();	
	ScanKeyWord(&Tmp,Str);

	Couleur("32");
	TurnOnBold();

	for(cpt=0;cpt<Tmp.nbKeyWord;cpt++){
		if(!strcmp(Tmp.keyWord[cpt],"oui")){
			printfDelay("> Rien a foutre ! ",1,1);
			Rep = 1;
		}
		if(!strcmp(Tmp.keyWord[cpt],"non")){
			printfDelay("> C'est pas bien de mentir !",1,1);
			Rep = 1;
		}
	}

	if(Rep == 0) printfDelay("> D'accord :) ",1,1);

	Couleur("0");
	TurnOnBold();

	return;
}*/


