/*
Nom : bot_file.c

Description : Gestion des fichier BOT

Fonctions 	: int MyRead(BOT *Struct, FILE *File, int nb);
			  void AddInFile(BOT *Struct, char *theme);
	
Ecrit par 	: Willy & Julian

Modifi le 	: 6 dcembre 2011

Version 	: 1.0 - Stable
*/
#include "bot_file.h"

/************************************************************************
Nom 		: MyRead

Paramtres	: Struct - Pointeur de type BOT pointant vers la structure
			  dans laquelle on souhaite crit les octets lus.
			  File - Pointeur de type File pointant vers le fichier o
			  l'on souhaite crire
			  nb - Entier donnant le nombre de structure  lire
			  
Description	: Cette fonction vient lire nb structure  partir de l'octet
			  point par File.
			  
Retourne 	: Cette fonction retourne le nombre d'octets lu si le pointeur
			  File est diffrent de null (Fichier ouvert), 0 sinon.
*************************************************************************/
int MyRead(BOT *Struct, FILE *File, int nb){	
	int nbReadByte=0;											/* Dclaration de la variable nombre d'octets lus initialis  0*/
	
	if(File == NULL)
		nbReadByte = -1;										/* Si le fichier n'existe pas, on  lu -1 octets */
	else
		nbReadByte = (int)fread(Struct,sizeof(BOT),nb,File);	/* Sinon on crit dans Struct la valeur et on stocke dans nbReadByte le nombre d'octets lus */
		
	return nbReadByte;											/* On retourne le nombre d'octets lus */
}

/************************************************************************
Nom 		: AddInFile

Paramtres	: Struct - Pointeur de type BOT pointant vers la structure
			  que l'on souhaite crire dans le fichier.
			  theme - Chaine de caractre contenant le nom du thme
			  
Description	: Cette fonction vient crire  la fin du fichier nom_theme.dat
			  la structure Struct.
			  
Retourne 	: Aucune valeur retourne
*************************************************************************/
void AddInFile(BOT *Struct, char *theme){

	char FileName[50];					/* On crer la variable FileName qui contiendra le nom du fichier (50 caractres max) */
	FILE *File;							/* Dclaration du pointeur File */

	strcpy(FileName,theme);				/* On copie le nom du thme dans la variable FileName */
	strcat(FileName,".dat");				/* On y ajoute l'extension .dat */

	File = fopen(FileName,"ab");			/* On ouvre le fichier binaire en criture en fin de fichier, ou on le crer s'il n'existe pas */

	fwrite(Struct,sizeof(BOT),1,File);	/* On crit la structure en fin de fichier */

	fclose(File);						/* On ferme le fichier */
}
