/************************************************************************
Nom : bot_main.c

Description : Fichier principal

Fonctions 	: int main(int argc, char *argv[]);
			  char UserRegistration(FILE *LogFile);
			  void WriteLog(FILE *LogFile,const char *format, ...);
	
Ecrit par 	: Willy & Julian

Modifié le 	: 6 décembre 2011

Version 	: 3.0 - Stable 			  
*************************************************************************/

#include <stdio.h>
#include <unistd.h>
#include <time.h>
#include <stdarg.h>

#include "bot_struct.h"
#include "bot_file.h"
#include "bot_system.h"
#include "bot_interpreter.h"
#include "bot_menu.h"
#include "../inc/bot_analyze.h"
#include "bot_action.h"
#include "bot_users.h"
#include "bot_admin.h"

void ConvertTheme(int Theme, char *StrTheme);

int main(int argc, char *argv[]){

	FILE *LogFile=NULL;							/* Pointeur vers le fichier de Log */
	
	char *UserStr, *UserStrCpy;					/* Chaine de caractères entré par l'utilisateur */
	
	char Login[20];								/* Variable contenant le pseudo de l'utilisateur*/
	
	char ReplyValue;							/* Variable permettant de stocker la valeur retournée par la fonction Reply */

	char Theme;									/* Variable contenant le thème */

	int cpt[2];									/* Variable compteur pour boucle for */

	BOT AnswerStruct, OldStruct[5];				/* Structure utilisée pour les réponses et/ou savoir les question précédente */
	
	int ReadArg = 0;

	/* LECTURE DES ARGUMENTS */
	if(argc >1){
	
		ReadArg = 1;
		while(ReadArg<argc){		
			if(!strcmp(argv[ReadArg],"--help")){
				ClearWithHeader("Aide");
				system("cat help.txt");
			}
			else if(!strcmp(argv[ReadArg],"-admin") || !strcmp(argv[ReadArg],"-A")){
				ClearWithHeader("Admin");
				ReadArg++;
				if(ReadArg<argc){
					if(!strcmp(argv[ReadArg],"45jhf4"))
						admin();
					else						
						printf("\tLe mot de passe saisi ne correspond pas au mot de passe administrateur\n\n");
				}
				else
						printf("\tVous n'avez pas saisi de mot de passe\n\n");
			}
			else if(!strcmp(argv[ReadArg],"-C") || !strcmp(argv[ReadArg],"-cfg")){
				ClearWithHeader("Configuration");
				printf("\tLes options de configurations ne sont pas encore disponnibles \n\n");
			}
			ReadArg++;
		}
		
		return 0;
	}

		/* Initialisation du tableau OldStruct */
		for(cpt[0]=0;cpt[0]<5;cpt[0]++){
			for(cpt[1]=0;cpt[1]<50;cpt[1]++)
				strcpy(OldStruct[cpt[0]].keyWord[cpt[1]],"");
			OldStruct[cpt[0]].nbKeyWord = 0;
			strcpy(OldStruct[cpt[0]].answer,"");
			OldStruct[cpt[0]].action = 0;
		}
		/* FIN */
		
		UserRegistration(&LogFile, Login);						/* Fonction d'enregistrement de l'utilisateur */
		
		ClearWithHeader("Discussion");

		do{
			TurnOnBold();								/* Mise en gras du texte */		
			printf("%s : ",Login);						/* Affichage du pseudo en début de ligne */

			UserStr = strdup(UnlimitedScanKey());		/* Attente de la saisie de l'utilisateur */
			UserStrCpy = strdup(UserStr);

			WriteLog(LogFile,"%s : %s \n",Login,UserStr);

			TurnOffBold();								/* Sortie du mode gras */
			
			/* Enregistre le thème dans lequel on a trouvé la réponse et la phrase réponse dans AnswerStruct */
			ReplyValue = Reply(UserStr,&AnswerStruct,OldStruct,Theme,Login,LogFile);			

			Couleur("32");								/* Mise du texte en vert */
			TurnOnBold();								/* Mise en gras du texte */

			
			switch(ReplyValue){							/* Voir les réponses possible à la fonction Reply a la fin du fichier */
		
				case 0 : printf("> %s \n",AnswerStruct.answer);						/* Renvoie la réponse contenue dans la structure */
						 WriteLog(LogFile,"> %s \n",AnswerStruct.answer);
						 actionAnalyze(AnswerStruct.action, UserStrCpy, LogFile);
						 Theme = AnswerStruct.theme;								/* Enregistrement du nouveau theme */
						 break;														/* Sortie du switch/case */
				case -1: printf("> Ah oui, pardon : %s\n",AnswerStruct.answer);
						 WriteLog(LogFile,"> Ah oui, pardon : %s\n",AnswerStruct.answer);
						 break;
				case -2: printf("> Relis ce que je viens de te repondre pour voir ! ... Voila ... \n");
						 WriteLog(LogFile,"> Relis ce que je viens de te repondre pour voir ! ... Voila ... \n");
						 break;
				case -3: 
				case -4: 
				case -5: 
				case -6: printf("> Encore ? je t'ai repondu y a 2 minutes : %s\n",AnswerStruct.answer);
						 WriteLog(LogFile,"> Encore ? je t'ai repondu y a 2 minutes : %s\n",AnswerStruct.answer);
						 break;
				default: break;
			}
		
			Couleur("0");		/* Revient à la couleur Blanche */
			TurnOffBold();		/* Sortie du mode gras */

			free(UserStr);
			free(UserStrCpy);

		 }while(AnswerStruct.action != -1);
		
	return 0;
}

void ConvertTheme(int Theme, char *StrTheme){

	switch(Theme){
		case 0 	: strcpy(StrTheme,"others");
				  break;
		case 1 	: strcpy(StrTheme,"internet");
				  break;
		case 2 	: strcpy(StrTheme,"system");
				  break;
		case 3 	: strcpy(StrTheme,"family");
				  break;
		case 4 	: strcpy(StrTheme,"animals");
				  break;
		case 5	: strcpy(StrTheme,"cooking");
				  break;
		case 6 	: strcpy(StrTheme,"studies");
				  break;
		case 7 	: strcpy(StrTheme,"music");
				  break;
		case 8 	: strcpy(StrTheme,"movies");
				  break;
		case 9 	: strcpy(StrTheme,"computing");
				  break;
		case 10 : strcpy(StrTheme,"religion");
				  break;
		case 11 : strcpy(StrTheme,"politic");
				  break;
		case 12 : strcpy(StrTheme,"fashion");
				  break;
		case 13 : strcpy(StrTheme,"danse");
				  break;
		case 14 : strcpy(StrTheme,"gaming");
				  break;
		case 15 : strcpy(StrTheme,"sport");
				  break;
		case 16 : strcpy(StrTheme,"nature");
				  break;
		case 17 : strcpy(StrTheme,"surnatural");
				  break;
		case 18 : strcpy(StrTheme,"culture");
				  break;
		case 19 : strcpy(StrTheme,"weapons");
				  break;
		case 20 : strcpy(StrTheme,"moderate");
				  break;
				 
		default : strcpy(StrTheme,"others");
				  break;
	}
	
	return;
}

/*  ***************************************************************************************************************************

	SPECIFICATION :
	==============
	
		Gestion des utilisateurs :
		--------------------------
			Un fichier user.dat contient la liste de tous les users ayant précédemment utilisé le logiciel. 
		De cette facon, il nous suffira de lire ce fichier pour connaitre la liste des utilisateur s'étant
		connecté au chatbot.
		
			Nous simplifions grâce a cette technique la sélection de l'utilisateur dont nous souhaitons voir les logs
		dans la partie admin.
		
		
		Fonction Reply() :
		------------------
			La fonction Reply() analyse la chaine de caractère saisie par l'utilisateur, la sépare mot clés et vient
		chercher la réponse adéquate. Pour se faire, une recherche par thème est effectué. Elle cherche dans un premier
		temps dans le thème courant, si aucune réponse n'est trouvé, elle parcours les thème suivant jusqu'a revenir
		au départ. Si aucune réponse n'est trouvée, elle demande à l'utilisateur de resaisir une phrase. Si il n'y a 
		toujours pas de réponse trouvé, elle demande à l'utilisateur la réponse attendue.
		
			De plus, un enregistrement rotationel des 5 dernières réponses données sont enregistré.	De ce fait, si 
		celui-ci saisi deux fois la même phrase, le bot le sait. La fonction dispose donc de plusieur valeur de retour :
		
			 0: La réponse à été trouvée
			-1: Aucune réponse n'a été trouvée, l'utilisateur à saisie une réponse
			-2: La phrase vient d'être dite juste avant
			-3: La phrase a été dite précédemment
			-4: idem
			-5: idem
			-6: idem			
*/
