/*
Nom : bot_menu.c

Description : Menu

Fonctions 	: int Menu(int NmbChoix, char *Subtitle, char *MenuTitle, char *str, ...);

Ecrit par 	: Willy & Julian

Modifi le 	: 6 dcembre 2011

Version 	: 2.0 - Stable
*/
#include "bot_menu.h"

/************************************************************************
Nom 		: Menu

Paramtres	: NmbChoix - Entier permettant de connatre le nombre de choix
			  du menu.
			  Subtitle - Chaine de caractres contenant le nom de la fentre
			  MenuTitle - Chaine de caractres contenant le nom du menu
			  str, ... - Chaines de caratres contenant le nom des options 
			  
Description	: Cette fonction affiche un menu  l'cran et permet une slection
			  grace aux flches directionnelle. La slection se fait pas la
			  touche entre.
			  
Retourne 	: Retourne la valeur du choix slectionn. Le dernier choix est 
			  gal  0 : Souvent utilis pour quitter.
*************************************************************************/
int Menu(int NmbChoix, char *Subtitle, char *MenuTitle, char *str, ...){
		
	char **VarMenu;				/* Variable contenant les diffrents choix du menu : Tableau 2D */
	char GetchVar;				/* Variable permettant de rcuprer les touches saisie par l'utilisateur */
	char *Arg;					/* Variable permettant de rcuprer toutes les chaines de caractres passes en arguments les unes aprs les autres */
	int Choice;					/* Variable contenant le choix selectionn */
	int Cpt;					/* Variable compteur pour boucles for */	
	
	va_list arguments;			/* Variable contenant la liste des arguments */
	va_start(arguments, str);	/* Enregistrement de la liste des arguments dans la variable */

	VarMenu = (char **) malloc(sizeof(char*)*NmbChoix);	/* Cration du menu 2D - Allocation de la premire case du tableau  la valeur NmbChoix */

	VarMenu[0] = malloc(strlen(str)*sizeof(char));		/* Allocation de la taille de la chaine de caractre str  la premire case du tableau */
	strcpy(VarMenu[0],str);								/* Copie de la chaine de caractre */

	for(Cpt = 1;Cpt<NmbChoix;Cpt++){
		Arg = va_arg(arguments, char *);				/* Rcupre l'adresse de l'argument x et l'enregistre dans la variable Arg */
		VarMenu[Cpt] = malloc(strlen(Arg)*sizeof(char));/* Alloue la mmoire ncessaire pour stocker la chaine de caractre  la case x du tableau*/
		strcpy(VarMenu[Cpt],Arg);						/* Copie la valeur de l'argument dans la variable */
	}

	va_end(arguments);									/* Fin de lecture des arguments */

	Choice = NmbChoix-1;								/* Selectionne le choix d'en haut de la liste */

	do{													/* On entre dans la boucle */
		ClearWithHeader(Subtitle);						/* Efface l'cran puis affiche le bandeau de prsentation avec le sous-titre pass en paramtre */
		printf("%s : \n\n",MenuTitle);					/* Affiche le titre du menu */

		for(Cpt=0;Cpt<NmbChoix;Cpt++){					/* Boucle parcourant tous les lments du menu */
			printf("\t");								/* Affiche une tabulation */
			if(Choice == ((NmbChoix-1)-Cpt)){			/* Teste si le choix affich est le choix slectionn */
				Couleur("34");							/* Couleur bleue */
				TurnOnBold();							/* Gras */
				printf("> ");							/* Affichage du caractre '>' devant le choix */
			}
			else{										/* Sinon */
				printf("  ");							/* Affichage d'un espace devant le menu */
				Couleur("0");							/* Remise a 0 de la couleur */
				TurnOffBold();							/* Sortie du mode gras */
			}
			printf("%s\n",VarMenu[Cpt]);				/* Affichage de l'option du menu */
			Couleur("0");								/* Remise  0 de la couleur */
			TurnOffBold();								/* Sortie du mode gras */
		}

		do{
			GetchVar = mygetch();									/* Rcupre la valeur de la touche prsse */
		}while(GetchVar != 65 && GetchVar != 66 && GetchVar != 10);	/* Tant qu'elle est diffrente de haut, bas, gauche, droite, entre */
		
		
		if(GetchVar == 65){											/* Si on appuie sur haut */
			if(Choice == (NmbChoix-1))	Choice = 0;					/* Si on est en haut on remet la variable Choice a 0 pour retourner en bas */
			else				Choice++;							/* Sinon on incrmente la variable Choice */
		}
		
		else if(GetchVar == 66){									/* Si on appuie sur bas */
			if(Choice == 0)	Choice = NmbChoix-1;					/* Si on est en bas on rinitialise la variable pour aller en haut */
			else 		Choice--;									/* Sinon on dcrmente la variable Choice */
		}

	}while(GetchVar != 10);											/* On sort de la boucle lorsque l'utilisateur  appuy sur entre */
	

	free(VarMenu);

	return Choice;													/* On sort de la fonction et on retourne la valeur de Choice */
	
}
